<template>
<v-layout row justify-center>
    <v-flex xs12 sm12 md12 v-if="!uploading">
        <input type="file"
                @change="onFileSelected"
                ref="fileInput"
                style="display:none"
            />
        <button class="uploadButton" @click.prevent="$refs.fileInput.click()" v-if="!ready">
            <v-icon>add_to_photos</v-icon> Selecciona archivo</button>

        <button class="actionButton" @click="onUpload" v-bind="upload" v-if="ready">
            <v-icon>cloud_upload</v-icon> Subir </button>
    </v-flex>

    <v-flex xs12 sm12 md12 v-if="uploading">
        <v-progress-linear v-model="counter"></v-progress-linear>
        <span class="dataName">{{ imageName.data }}</span>
        <span>
            <button @click="onDelete">
                <v-icon>delete</v-icon>
            </button>
        </span>
    </v-flex>
</v-layout>
</template>

<script>
import server from '../server.js'
import axios from 'axios'

export default {
    name: 'UploadImage',
    data() {
        return {
            ready: false,
            uploading: false,
            upload: false,
            image: null,
            imageName: '',
            counter: 0,
        }
    },
    model: {
        prop: 'image',
        event: 'upload',
    },
    methods: {
        onFileSelected(event) {
            this.image = event.target.files[0];
            this.ready = true;
        },

        onUpload(e) {
            e.preventDefault();
            this.uploading = true;
            let string = `${server}/api/task/images`;

            const fd = new FormData();

            fd.append('image', this.image, this.image.name);

            axios.post(string, fd, {
                headers: {
                    Authorization: this.$store.getters.getAccessToken
                },
                onUploadProgress: uploadEvent => {
                    this.counter = (Math.round(uploadEvent.loaded / uploadEvent.total * 100))
                }
            }).then(resp => {
                this.imageName = resp;
                this.failed = true;
                this.message = "Imagen exportada exitosamente";
                this.$emit('upload', this.imageName.data);
            })
        },
        onDelete(e) {
            e.preventDefault();
            this.uploading = false;
            this.ready = false;
            this.image = null;
            this.upload = false;
            this.imageName = '';
            this.counter = 0;
        }
    }
}
</script>

<style>
.uploadButton {
    padding: 10px;
    background-color: bisque;
    margin-right: 15px;
}

.actionButton {
    padding: 10px;
    background-color:orangered;
    color: white;
}
</style>
